

import javax.microedition.lcdui.*;
import java.util.*;

// Author Sreejith@Blue-Gene

public class MessageUI extends Canvas implements CommandListener
{
  Vector msgs = new Vector();
  int midx = 0;
  int w, h;
  int fh;
  Font f;
  InputUI inputui=new InputUI();
  String msg;
  NetLayer btnet;
  int x0=0, y0=0;
 Command joinscatter =new Command("Form Scatternet", Command.SCREEN, 3);
 Display display;
 
  public MessageUI(NetLayer btnet,Display display)
  {
        this.btnet=btnet;
        this.display=display;
        addCommand(new Command("Write", Command.SCREEN, 1));
        addCommand(new Command("Clear", Command.SCREEN, 2));
        addCommand(new Command("List Slaves", Command.SCREEN, 2));
        addCommand(new Command("List All", Command.SCREEN, 2));
        addCommand(new Command("Back", Command.SCREEN, 2));
        addCommand(new Command("Exit", Command.EXIT, 1));
        addCommand(joinscatter);
        setCommandListener(this);
  }
  public void clearLog()
  {
      msgs.removeAllElements();
      
           
  }

  protected void paint(Graphics g)
  {

    if ( f == null )
    {
      // cache the font and width,height value
      // when it is used the first time
      f = Font.getFont(  Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_SMALL );
      w = this.getWidth();
      h = this.getHeight();
      fh = f.getHeight();
    }
    //
    // detemine midx based on the screen height and number of message
    /*
    midx = msgs.size() - (h/fh) ;
    if ( midx < 0 )
      midx = 0;
        */
    int y = fh; // 1st line y value

    // message will be rendered in black color, on top of white backgound
    g.setColor( 255, 255, 255 );
    g.fillRect( 0, 0, w, h );
    g.setColor( 0, 0, 0 );
    g.setFont( f );

    g.translate(-x0, -y0);

    // render the messages on screen
    for ( int i= midx; i< msgs.size(); i++ )
    {
      Packet p = (Packet)msgs.elementAt(i);
      String s = p.sender+": "+p.msg;
      g.drawString( s, 0, y, Graphics.BASELINE | Graphics.LEFT );
      y += fh;
    }

  }

  public void keyPressed( int key )
  {
    if ( getGameAction( key ) == Canvas.RIGHT )
    {
      x0+=50;
    } else if ( getGameAction( key ) == Canvas.LEFT )
    {
      x0-=50;
    } else if ( getGameAction( key ) == Canvas.UP )
    {
      // note: change this from 50 to 100 if you want to scroll faster
      y0-=50;
    } else if ( getGameAction( key ) == Canvas.DOWN )
    {
      // note: change this from 50 to 100 if you want to scroll faster
      y0+=50;
    }
    repaint();
  }
 public void sendMessage(String s)
{
     btnet.sendString( btnet.SIGNAL_MESSAGE,msg ,btnet.bluetoothaddress,s);
     Packet packet = new Packet( NetLayer.SIGNAL_MESSAGE, btnet.localName,  msg );
     msgs.addElement( packet );
     display.setCurrent( this );
     repaint();
}
    public void commandAction(Command c, Displayable d) {
        if ( c.getLabel().equals("Form Scatternet") )
        { 
            btnet.query();
        }
        else if ( c.getLabel().equals("List Slaves") )
        { 
            btnet.listSlaveAndMAster();
        }
        else if (c.getLabel().equals("List All") )
        { 
            btnet.listAllDevices();
        }
        else if (c.getLabel().equals("Write") )
        {
            display.setCurrent( inputui );
            inputui.showUI(); 

       }
        else if  (c.getLabel().equals("Back") )
        {
            display.setCurrent(Scattercom.instance.profile);
        }

    }

    public void toSendUI() {
           
            msg = inputui.getString();
            btnet.sendUI(NetLayer.SIGNAL_MESSAGE);//type is set to 2
    }
    

}
